package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.UniRes;
import com.sa.ibiz.demo.demo.service.UniResService;
import com.sa.ibiz.demo.demo.service.dto.UniResSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/unires")
public class UniResResource
{
	@Autowired
	private UniResService service;


	@PostMapping(value = "/getDraft")
	public ResponseEntity<UniRes> getDraft(@Validated @RequestBody UniRes data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("统一资源[getDraft]操作发生错误","UniRes","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<UniRes> remove(@Validated @RequestBody UniRes data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("统一资源[remove]操作发生错误","UniRes",data.getUniresid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<UniRes> checkKey(@Validated @RequestBody UniRes data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("统一资源[checkKey]操作发生错误","UniRes",data.getUniresid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<UniRes> create(@Validated @RequestBody UniRes data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("统一资源[create]操作发生错误","UniRes",data.getUniresid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<UniRes> get(@Validated @PathVariable String id){
		UniRes data=new UniRes();
		data.setUniresid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("统一资源[get]操作发生错误","UniRes",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<UniRes> update(@Validated @RequestBody UniRes data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("统一资源[update]操作发生错误","UniRes",data.getUniresid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<UniRes>> searchDefaultPage(@Validated @RequestBody UniResSearchFilter filter){
		Page<UniRes> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<UniRes>> listDefault(@Validated @RequestBody UniResSearchFilter filter){
		List<UniRes> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
